import java.net.*;
import javax.media.*;
import javax.media.protocol.*;
import javax.media.format.*;
import javax.media.control.*;
import javax.media.rtp.*;
import javax.media.rtp.event.*;
import java.util.*;
import com.sun.media.rtp.*;

//Esta clase se encarga del manejo multimedia de la recion. 
//En este caso es solo una herramienta de captura de y reproduccion de audio
public class VoiceTool implements ReceiveStreamListener {

  private RTPSessionMgr myVoiceSessionManager=null;
  private Processor myProcessor=null;
  private SendStream ss=null;
  private ReceiveStream rs=null;
  private Player player=null;
  private AudioFormat af=null;

public void startMedia(String peerIP,int peerPort,int recvPort, int fmt) {

  try{
    //Obtenemos la fuentes de audio  del computador con codificacion 
      //linear a 8000 kbps con 8 bits por muestra y nos quedamos con 
      //la 1era fuente de audio que encontremos (en microfono normalmente)
    AudioFormat df=new AudioFormat(AudioFormat.LINEAR,8000,8,1);
    Vector devices=CaptureDeviceManager.getDeviceList(df);
    CaptureDeviceInfo di=(CaptureDeviceInfo) devices.elementAt(0);
    DataSource daso=Manager.createDataSource(di.getLocator());

   //Procesamos la fuenta para conseguir un streaming de esta
   myProcessor = Manager.createProcessor(daso);
   myProcessor.configure();
   while (myProcessor.getState()!=Processor.Configured) {
   Thread.sleep(10);
  }
   myProcessor.setContentDescriptor(new ContentDescriptor(ContentDescriptor.RAW_RTP));
   TrackControl track[] = myProcessor.getTrackControls();
   switch (fmt) {
     case 3: af=new AudioFormat(AudioFormat.GSM_RTP,8000,4,1);
     case 4: af=new AudioFormat(AudioFormat.G723_RTP,8000,4,1);
   }
   track[0].setFormat(af);
   myProcessor.realize();
   while (myProcessor.getState() != Processor.Realized) {}
   DataSource ds = myProcessor.getDataOutput();

   //Creamos un administrador de sesion RTP (para el streamming RTP)
    myVoiceSessionManager = new RTPSessionMgr();

    //Agregamos el listener para recibir audio
    myVoiceSessionManager.addReceiveStreamListener(this);

    //Inicializamos la sesion
    SessionAddress senderAddr = new SessionAddress();
    myVoiceSessionManager.initSession(senderAddr, null, 0.05, 0.25);
    InetAddress destAddr = InetAddress.getByName(peerIP);
    SessionAddress localAddr =
        new SessionAddress (InetAddress.getLocalHost(),recvPort,InetAddress.getLocalHost(),recvPort + 1);
    SessionAddress remoteAddr = new SessionAddress(destAddr, peerPort, destAddr, peerPort + 1);
    myVoiceSessionManager.startSession(localAddr , localAddr , remoteAddr,null);

   //Obtenemos el streaming listo para ser enviado
   ss = myVoiceSessionManager.createSendStream(ds, 0);

   //Comenzamos la captura y transmision
   ss.start();
   myProcessor.start();

 }catch(Exception e){
       e.printStackTrace();
     }
  }

  public void stopMedia() {
    try{

      //Detiene y cierra el reproductor
      player.stop();
      player.deallocate();
      player.close();

      //stop sending
      ss.stop();

      //Detiene la captura y procesamiento
      myProcessor.stop();
      myProcessor.deallocate();
      myProcessor.close();

      //Cierra la sesion RTP y libera los puertos usados
      myVoiceSessionManager.closeSession("terminated");
      myVoiceSessionManager.dispose();

    }catch(Exception ex) {
       ex.printStackTrace();
    }
  }

  public void update(ReceiveStreamEvent event) {
    if (event instanceof NewReceiveStreamEvent){
      rs=event.getReceiveStream();
      DataSource myDS=rs.getDataSource();
      try{
        player = Manager.createRealizedPlayer(myDS);
      }catch (Exception ex){
        ex.printStackTrace();
      }
      player.start();
    }
  }
}